/* 
    BattleRPG Copyright (C) 2007-2008 Nico de Vries.

    This file is part of BattleTRANS.

    BattleTRANS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/.
*/

class BattleTranslocator extends UTWeap_Translocator_Content HideDropDown;

var int CountDownForWarp;
var bool bWarpDrive;
var Projectile TD;

// Unlimited ammo
simulated function bool HasAmmo(byte FireModeNum, optional int Amount)
{
  AmmoCount = 7;
  return super.HasAmmo(FireModeNum, Amount);
}

simulated function String GetHumanReadableName()
{
  return "Battle Translocator with Warp Drive";
}

simulated function Projectile ProjectileFire()
{
  TD = Super.ProjectileFire();
  if (TD != None) {
    CountDownForWarp = 2; // Tested this to be the lowest value without flicker quirks in networked mode
  } else {
    ImpulseDrive();
  }
  return TD;
}

simulated function Tick(float DeltaTime)
{
  if (CountDownForWarp > 0 && TD != None) {
    if (--CountDOwnForWarp == 0) {
      WarpDrive ();
    }
  }
  if (WorldInfo.NetMode != NM_Client) { // Only do this on the server
    if (bWarpDrive && UTPawn(Instigator.Controller.Pawn) != None && UTPawn(Instigator.Controller.Pawn).Weapon.Class != class'BattleTranslocator') {
      ImpulseDrive ();
    }
  }
}

simulated function WarpDrive ()
{
  bWarpDrive = true;
  PlayerController(Instigator.Controller).SetViewTarget (TD);
  PlayerController(Instigator.Controller).ClientSetViewTarget (TD);
//PlayerController(Instigator.Controller).SetRotation (TD.Rotation); // Not wanted!

}

simulated function ImpulseDrive () // aka walking
{
  bWarpDrive = false;
  PlayerController(Instigator.Controller).SetViewTarget (Instigator.Controller.Pawn);
  PlayerController(Instigator.Controller).ClientSetViewTarget (Instigator.Controller.Pawn);
//PlayerController(Instigator.Controller).SetRotation (Instigator.Controller.Pawn.Rotation); // Not needed
}

defaultproperties
{
  WeaponProjectiles(0)=Class'BattleTRANS.BattleTransDiscRed'
  WeaponProjectiles(1)=Class'BattleTRANS.BattleTransDiscBlue'
  Name="BattleTranslocator"
}